#!/usr/bin/env python
import sys, time, Queue, os
from threading import *
from numpy import *
from qt import *
from window import Window
import cv_hp4284

class GraphThread(Thread):

	def __init__(self, wid, *args):
		self.queue=wid.queue
		self.wid=wid
		apply(Thread.__init__, (self, ) + args)

	def run(self):
		while 1:
			while self.queue.qsize ():
				try:
					msg = self.queue.get ( 0 )
					nfreq=int(msg[0])
					spect=msg[1]
					results=array(msg[2],Float)
					self.wid.capacitancePL.setCurveData(self.wid.cvf1,results[:,0],results[:,1])
					self.wid.conductancePL.setCurveData(self.wid.gvf1,results[:,0],results[:,2])
					if (nfreq==2):
						self.wid.capacitancePL.setCurveData(self.wid.cvf2,results[:,0],results[:,3])
						self.wid.conductancePL.setCurveData(self.wid.gvf2,results[:,0],results[:,4])
					if (spect=='Double'):
						self.wid.capacitancePL.setCurveData(self.wid.cvf3,results[:,5],results[:,6])
						self.wid.conductancePL.setCurveData(self.wid.gvf3,results[:,5],results[:,7])
						if (nfreq==2):
							self.wid.capacitancePL.setCurveData(self.wid.cvf4,results[:,5],results[:,8])
							self.wid.conductancePL.setCurveData(self.wid.gvf4,results[:,5],results[:,9])
					self.wid.capacitancePL.replot()
					self.wid.conductancePL.replot()
				except Queue.Empty:
					pass
			if self.wid.is_running<1:
				if self.wid.is_running==0:
					while (self.wid.is_running!=1):#Wait for measurement to quit
						print self.wid.is_running
						time.sleep(0.2)
				self.wid.close()
				#a.exit(0)
				sys.exit(0)
			time.sleep(0.1)



def main(args):
	app=QApplication(args)
	w=Window()
	app.setMainWidget(w)

	w.queue = Queue.Queue ()	# Plot (result) queue
	w.gthread=GraphThread(w)
	w.gthread.start()

	w.show()
	#app.connect(app, SIGNAL("lastWindowClosed()"), w, quitS() )
	app.exec_loop()

if __name__=="__main__":
	main(sys.argv)
